<template>
  <v-dialog
    v-model="show"
    width="1000"
    transition="dialog-bottom-transition"
    :scrollable="false"
  >
    <v-card>
      <v-toolbar :color="color">
        <h3 :style="{ color: $vuetify.theme.isDark ? '#FFF' : '#000' }">
          QUIEN ES ESTE POKEMON
        </h3>
      </v-toolbar>
      <v-card-text>
        <v-row no-gutters>
          <v-col :cols="$vuetify.breakpoint.xs ? 12 : 5 " >
            <v-img
              :src="oPokemon.cover"
              rounded
              max-width="250"
              class="mt-3"
            ></v-img>
          </v-col>
          <v-col :cols="$vuetify.breakpoint.xs ? 12 : 7">
            <v-card-title :style="{display: $vuetify.breakpoint.xs ? 'block' : 'flex'}">
              <h3 class="font-weight-black w-100 text-center">
                {{ oPokemon.name | upperCase }}
              </h3>
            </v-card-title>
            <v-card-text>
              <div>
                <h3 class="font-weight-black mb-1">SKILLS</h3>
                <v-sheet
                  :style="{overflow: 'auto'}"
                  class="d-flex align-center flex-wrap text-center mx-auto px-4"
                  elevation="3"
                  :height="$vuetify.breakpoint.xs ? 100 : 50"
                  width="100%"
                >
                  <v-chip
                  small
                    class="ma-2"
                    variant="outlined"
                    v-for="(abilitie, index) in oPokemon.details.abilities"
                    :key="`${index}_abilitie`"
                    label
                  >
                    <v-icon start>mdi-check-all</v-icon>
                    {{ abilitie.ability.name }}
                  </v-chip>
                </v-sheet>
                <v-divider />
                <v-row>
                  <v-col>
                    <div class="d-flex content-images">
                      <v-img
                        v-for="(sprite, index) in oPokemon.details.sprites"
                        :key="`${index}_sprite`"
                        :src="sprite"
                      ></v-img>
                    </div>
                  </v-col>
                </v-row>
                <div>
                  <h3 class="font-weight-black mb-1">STATS</h3>
                  <v-divider />
                  <div
                    v-for="(stat, index) in oPokemon.details.stats"
                    :key="`${index}_stat_`"
                  >
                    {{ stat.stat.name }}
                    <v-progress-linear
                      model-value="10"
                      :color="onProgress(stat.base_stat)"
                      height="10"
                      striped
                      :value="stat.base_stat"
                    >
                      <strong>{{ stat.base_stat }}%</strong>
                    </v-progress-linear>
                  </div>
                </div>
              </div>
            </v-card-text>
          </v-col>
        </v-row>
      </v-card-text>
      <v-card-actions>
        <v-row>
          <v-col class="text-right mb-2">
            <v-btn small color="primary" @click="show = false">
              Cerrar <v-icon>mdi-close-circle-outline</v-icon>
            </v-btn>
          </v-col>
        </v-row>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
<script>
import { VDataTable } from "vuetify/lib";
export default {
  components: {
    VDataTable,
  },
  filters: {
    upperCase(value) {
      if (!value) return "";
      // Si la variable es diferente de string
      if (typeof value !== "string") {
        return value;
      }
      // El valor contiene caracteres especiales que no se pueden convertir a mayúsculas
      if (/[^a-zA-Z\s]/.test(value)) {
        return value;
      }
      return value.toUpperCase();
    },
  },
  data() {
    return {
      show: false,
      // Este objeto contendrá toda la información del pokemon seleccionado
      // la información se seteará usando ref del componente
      oPokemon: {},
    };
  },
  methods: {
    onProgress(value) {
      if (value < 30) {
        return "red";
      } else if (value >= 30 && value < 65) {
        return "warning";
      } else if (value >= 65 && value < 80) {
        return "#01579B";
      } else {
        return "#009688";
      }
    },
  },
  computed: {
    color() {
      const [type] = this.oPokemon.details.types;
      console.log(type.type);
      const oColors = {
        fire: "red",
        water: "#0288D1",
        electric: "yellow",
        ground: "brown",
        poison: "#004D40",
        fairy: "#BDBDBD",
        grass: "success",
        bug: "#424242",
        rock: "#546E7A",
        psychic: "#00B8D4",
        fighting: "#3949AB",
        ice: "#1565C0",
        dragon: "#0097A7",
        dark: "#000000",
        ghost: "#BDBDBD",
      };

      return oColors[type.type.name] || "primary";
    },
  },
};
</script>
<style scoped>
.v-progress-circular {
  margin: 1rem;
}
.content-images {
  width: 100% !important;
  overflow: auto;
}
</style>